// Code generated by mockery v2.42.3. DO NOT EDIT.

package mock_authorization

import (
	authentication "gitlab.com/commonground/nlx/fsc-nlx/controller/pkg/authentication"
	authorization "gitlab.com/commonground/nlx/fsc-nlx/controller/pkg/authorization"

	authz "gitlab.com/commonground/nlx/fsc-nlx/controller/adapters/authz"

	context "context"

	mock "github.com/stretchr/testify/mock"
)

// MockAuthorization is an autogenerated mock type for the Authorization type
type MockAuthorization struct {
	mock.Mock
}

type MockAuthorization_Expecter struct {
	mock *mock.Mock
}

func (_m *MockAuthorization) EXPECT() *MockAuthorization_Expecter {
	return &MockAuthorization_Expecter{mock: &_m.Mock}
}

// Authorize provides a mock function with given fields: ctx, authenticationData, metadata, action, resourceURNs
func (_m *MockAuthorization) Authorize(ctx context.Context, authenticationData authentication.Data, metadata authorization.Metadata, action authz.Action, resourceURNs []*authz.ResourceURN) error {
	ret := _m.Called(ctx, authenticationData, metadata, action, resourceURNs)

	if len(ret) == 0 {
		panic("no return value specified for Authorize")
	}

	var r0 error
	if rf, ok := ret.Get(0).(func(context.Context, authentication.Data, authorization.Metadata, authz.Action, []*authz.ResourceURN) error); ok {
		r0 = rf(ctx, authenticationData, metadata, action, resourceURNs)
	} else {
		r0 = ret.Error(0)
	}

	return r0
}

// MockAuthorization_Authorize_Call is a *mock.Call that shadows Run/Return methods with type explicit version for method 'Authorize'
type MockAuthorization_Authorize_Call struct {
	*mock.Call
}

// Authorize is a helper method to define mock.On call
//   - ctx context.Context
//   - authenticationData authentication.Data
//   - metadata authorization.Metadata
//   - action authz.Action
//   - resourceURNs []*authz.ResourceURN
func (_e *MockAuthorization_Expecter) Authorize(ctx interface{}, authenticationData interface{}, metadata interface{}, action interface{}, resourceURNs interface{}) *MockAuthorization_Authorize_Call {
	return &MockAuthorization_Authorize_Call{Call: _e.mock.On("Authorize", ctx, authenticationData, metadata, action, resourceURNs)}
}

func (_c *MockAuthorization_Authorize_Call) Run(run func(ctx context.Context, authenticationData authentication.Data, metadata authorization.Metadata, action authz.Action, resourceURNs []*authz.ResourceURN)) *MockAuthorization_Authorize_Call {
	_c.Call.Run(func(args mock.Arguments) {
		run(args[0].(context.Context), args[1].(authentication.Data), args[2].(authorization.Metadata), args[3].(authz.Action), args[4].([]*authz.ResourceURN))
	})
	return _c
}

func (_c *MockAuthorization_Authorize_Call) Return(_a0 error) *MockAuthorization_Authorize_Call {
	_c.Call.Return(_a0)
	return _c
}

func (_c *MockAuthorization_Authorize_Call) RunAndReturn(run func(context.Context, authentication.Data, authorization.Metadata, authz.Action, []*authz.ResourceURN) error) *MockAuthorization_Authorize_Call {
	_c.Call.Return(run)
	return _c
}

// NewMockAuthorization creates a new instance of MockAuthorization. It also registers a testing interface on the mock and a cleanup function to assert the mocks expectations.
// The first argument is typically a *testing.T value.
func NewMockAuthorization(t interface {
	mock.TestingT
	Cleanup(func())
}) *MockAuthorization {
	mock := &MockAuthorization{}
	mock.Mock.Test(t)

	t.Cleanup(func() { mock.AssertExpectations(t) })

	return mock
}
